#include <iostream>

int main()
{
    std::ios::sync_with_stdio(false);
    int N, Q;
    std::cin >> N >> Q;
    int A[N+1];
    for(int i=1; i<=N; i++) std::cin >> A[i];
    int L, R, res;
    for(int i=0; i<Q; i++)
    {
        std::cin >> L >> R;
        res=A[L];
        for(int j=L+1; j<=R; j++) res&=A[j];
        std::cout << res << "\n";
    }
    return 0;
}